| GL Studio C++ Runtime API

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
GlsRSOWrapper Class Reference

`#include <gls_rso_wrapper.h>`

Inheritance diagram for GlsRSOWrapper:

## Public Types
typedef ComponentBase | _BaseClass
| Deprecated typedef for the base class.
typedef ComponentBase | BaseClass
| Typedef for the base class.
Public Types inherited from ComponentBase
typedef Group | _BaseClass
| Deprecated typedef for the base class.
typedef Group | BaseClass
| Typedef for the base class.
Public Types inherited from Group
typedef DisplayObject | _BaseClass
| Deprecated typedef for the base class.
typedef DisplayObject | BaseClass
| Typedef for the base class.
Public Types inherited from DisplayObject
enum | AvailableAttributesEnum { GLS_ATTRIBUTES_BASIC = 1 , GLS_ATTRIBUTES_DYNAMIC = 2 , GLS_ATTRIBUTES_APPEARANCE = 4 , GLS_ATTRIBUTES_GEOMETRY = 8 , GLS_ATTRIBUTES_SPECIALIZED = 16 , GLS_ATTRIBUTES_ALL = ~0 , GLS_ATTRIBUTES_NONE = 0 }

## Public Member Functions
| GlsRSOWrapper (RsoImplBaseInterface *rso, unsigned int RSOVersion)
virtual | ~GlsRSOWrapper ()
virtual void | DeleteInstance ()
void | ChangeRSO (RsoImplBaseInterface *rso, bool deleteCurrent=true)
RsoImplBaseInterface * | RSOInterface ()
unsigned int | GetRSOVersion () const
int | HandleEmittedEvent (RsoImplBaseInterface::Event *ev)
const char * | LastEmittedEventInitiatorName () const
virtual void | AlphaMode (int mode) override
virtual int | AlphaMode () override
virtual void | AntiAlias (bool alias) override
virtual bool | AntiAlias () override
virtual void | SetBlendColor (const GlsColor &color) override
virtual GlsColor | GetBlendColor () override
virtual GlsColor | GetColor () override
virtual void | SetColor (const GlsColor &color) override
virtual void | CullBackFace (const bool val) override
virtual bool | CullBackFace () override
virtual int | DepthTest () override
virtual void | DepthTest (unsigned char zbuf) override
virtual bool | LightingEnabled () override
virtual void | LightingEnabled (bool lighting) override
virtual int | LineStippleMultiplier () override
virtual void | LineStippleMultiplier (int mult) override
virtual int | LineStipplePattern () override
virtual void | LineStipplePattern (int pattern) override
virtual float | LineWidth () override
virtual void | LineWidth (float width) override
virtual int | MaterialIndex () override
virtual void | MaterialIndex (int index) override
virtual int | PolygonMode () override
virtual void | PolygonMode (int mode) override
virtual int | PolygonEnd () override
virtual void | PolygonEnd (const int end) override
virtual int | Shading () override
virtual void | Shading (const int shading) override
virtual int | TextureIndex () override
virtual void | TextureIndex (int textureIndex) override
virtual bool | TextureRepeat () override
virtual void | TextureRepeat (const int rep) override
virtual int | TextureMappingTechnique () override
virtual void | TextureMappingTechnique (const int map) override
virtual int | TextureMagnificationFilter () override
virtual void | TextureMagnificationFilter (const int filter) override
virtual int | TextureMinificationFilter () override
virtual void | TextureMinificationFilter (const int filter) override
virtual void | AbsolutePlacement (bool val) override
virtual void | Calculate (double time) override
virtual void | CalculateBoundingBox () override
virtual DisplayObject * | CloneObject (bool generateNames=false) override
virtual void | CopyGeometry (DisplayObject *src) override
virtual void | CopyProperties (DisplayObject *src) override
virtual void | CreateObjects () override
virtual void | Draw () override
virtual void | GetExtents (float &x, float &y, float &z, float &x1, float &y1, float &z1) override
virtual void | GetTransformedExtents (Vector &min, Vector &max, const GlsMatrixType &matrix, bool resetMinMax=true) override
virtual DisplayObject * | handle (DisplayEvent *ev) override
virtual DisplayObject * | HandleInput (DisplayEvent *ev) override
virtual void | Init () override
virtual void | Initialize () override
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices) override
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler) override
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL) override
virtual DistiAttributeBase & | Resource (const char *name) override
virtual void | UpdateBoundingVolume () override
void | SetValue (int spec, va_list &args) override
virtual void | Invalidate ()
| Invalidates the painter set on this object if that painter exists.
virtual void | SetPainter (GlsPainter *painter) override
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | Scale (float px, float py, float pz, Vertex *parentAnchor, int handleBar=0) override
virtual void | Scale (float scale_x, float scale_y)
void | Scale (float scale_x, float scale_y, float scale_z, Vertex *anchor=NULL, int handle=0) override
Public Member Functions inherited from ComponentBase
| ComponentBase (int generateInstance=0)
virtual | ~ComponentBase ()
virtual void | SetAvailableAttributes (unsigned int value) override
bool | AbsolutePlacement () const
virtual void | ChangedAbsolutePlacement (bool val)
virtual void | AbsolutePlacement (bool val)
virtual void | CalculateBoundingBox () override
virtual void | ClearDragAndFocus () override
virtual DisplayObject * | CloneObject (bool generateNames=false) override
virtual void | CopyGeometry (DisplayObject *src) override
virtual void | CopyProperties (DisplayObject *src) override
virtual void | CreateObjects ()
virtual void | DeleteAllChildren () override
virtual void | Draw () override
virtual DisplayObject * | FindByNameSameFrame (const char *name) override
virtual void | GetExtents (float &x, float &y, float &z, float &x1, float &y1, float &z1) override
virtual void | GetTransformedExtents (Vector &min, Vector &max, const GlsMatrixType &matrix, bool resetMinMax=true) override
virtual DisplayObject * | HandleInput (DisplayEvent *ev)
virtual void | Init ()
virtual void | Initialize ()
LiveComponentAccessor * | LiveAccessor ()
virtual const Vertex & | Location () const override
virtual void | Location (const Vertex &v) override
virtual void | Location (float x, float y, float z) override
virtual void | Parent (DisplayFrame *par) override
DisplayFrame * | ParentDisplayFrame () const
void | ParentDisplayFrame (DisplayFrame *val)
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices) override
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler) override
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL) override
virtual DistiAttributeBase & | Resource (const char *name) override
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | Scale (float px, float py, float pz, Vertex *parentAnchor, int handleBar=0) override
virtual void | SetRedraw () override
virtual void | Translate (float tr[]) override
virtual void | Translate (float x, float y, float z) override
virtual void | UseParentsLighting (const bool &)
virtual bool | UseParentsLighting ()
virtual int | TextureIndex () override
virtual void | TextureIndex (int index) override
void | SetValue (int spec, va_list &args) override
virtual InputHandler * | GetInputHandler () override
void | NotifyAttributeChanged (const AttributeName &name) override
virtual void | Location (const Vertex &v) override
virtual void | Location (float x, float y, float z) override
virtual void | Parent (DisplayFrame *par) override
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | Scale (float scale_x, float scale_y)
void | Scale (float scale_x, float scale_y, float scale_z, Vertex *anchor=NULL, int handle=0) override
Public Member Functions inherited from Group
DisplayObject * | FindByName (const char *name)
virtual DisplayObject * | FindByNameSameFrame (const char *name)
DisplayObject * | FindByName (DisplayObject *obj)
DisplayObject * | FindByQualifiedName (const char *name)
DisplayObject * | FindNonRecursive (DisplayObject *obj)
DisplayObjectArray & | Objects ()
const DisplayObjectArray & | Objects () const
DisplayObject * | Item (unsigned int index)
bool | PerformGroupCullCheck () const
void | PerformGroupCullCheck (bool mode)
bool | CullTestChildren () const
void | CullTestChildren (bool mode)
unsigned int | Count () const
DisplayObjectPtr | operator[] (unsigned int index)
const DisplayObject * | operator[] (unsigned int index) const
DisplayObject * | FirstObject ()
DisplayObject * | LastObject ()
bool | IsEmpty () const
int | Position (const DisplayObject *obj) const
| Group (int generateInstance=0)
| Group (const Group &group, bool generateNames)
void | InitialGroupCount (unsigned int cnt)
virtual | ~Group ()
virtual void | DeleteAllChildren ()
virtual void | SetAvailableAttributes (unsigned int value) override
virtual DisplayObject * | CloneObject (bool generateNames=false) override
virtual void | CopyGeometry (DisplayObject *src) override
virtual void | CopyProperties (DisplayObject *src) override
virtual void | Draw () override
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler) override
virtual bool | Hit (float x, float y, float z, float scale, const Vector &directionVector, Vector *collisionPoint) override
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices) override
virtual void | Parent (DisplayFrame *par) override
void | SetPainter (GlsPainter *painter) override
virtual void | CalculateBoundingBox ()
virtual void | Location (const Vertex &v) override
virtual void | Location (float x, float y, float z) override
virtual void | Translate (float x, float y, float z) override
virtual void | Translate (float transAmount[]) override
virtual void | TranslateVertices (float x, float y, float z) override
virtual void | TranslateVertices (float transAmount[])
virtual void | GetExtents (float &x, float &y, float &z, float &x1, float &y1, float &z1) override
virtual void | GetTransformedExtents (Vector &min, Vector &max, const GlsMatrixType &matrix, bool resetMinMax=true) override
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis) override
virtual void | Scale (float scale_x, float scale_y)
void | Scale (float scale_x, float scale_y, float scale_z, Vertex *anchor=NULL, int handle=0) override
virtual void | InsertObject (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=-1)
virtual bool | DeleteObject (DisplayObject *obj, bool recalculateBoundingbox=true)
virtual void | ReorderObject (unsigned int oldIndex, unsigned int newIndex)
virtual void | PushObject (DisplayObject *obj)
void | DeleteVertexAt (unsigned) override
void | InsertVertexAt (unsigned) override
virtual void | SetGroupLocation (const Vertex &v)
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL) override
virtual void | CalculateTextureCoordinates () override
virtual void | LineWidth (float width) override
virtual float | LineWidth () override
virtual void | LineStipplePattern (int pattern) override
virtual int | LineStipplePattern () override
virtual void | LineStippleMultiplier (int mult) override
virtual int | LineStippleMultiplier () override
virtual int | PolygonMode () override
virtual void | PolygonMode (int mode) override
virtual void | PolygonEnd (const int mode) override
virtual int | PolygonEnd () override
virtual void | Shading (const int mode) override
virtual int | Shading () override
virtual void | DepthTest (unsigned char mode) override
virtual int | DepthTest () override
virtual void | AntiAlias (bool mode) override
virtual bool | AntiAlias () override
virtual void | AlphaMode (int mode) override
virtual int | AlphaMode () override
virtual void | CullBackFace (const bool mode) override
virtual bool | CullBackFace () override
virtual bool | LightingEnabled () override
virtual void | LightingEnabled (bool lighting) override
virtual void | SetBlendColor (const GlsColor &color) override
virtual GlsColor | GetBlendColor () override
virtual void | SetColor (const GlsColor &color) override
virtual GlsColor | GetColor () override
virtual void | SetFillColor (const GlsColor &color) override
virtual GlsColor | GetFillColor () override
virtual void | TextureRepeat (const int rep) override
virtual void | TextureMappingTechnique (const int map) override
virtual int | TextureMappingTechnique () override
virtual void | TextureMinificationFilter (const int filter) override
virtual int | TextureMinificationFilter () override
virtual void | TextureMagnificationFilter (const int filter) override
virtual int | TextureMagnificationFilter () override
virtual void | Calculate (double time) override
CompatabilityListItem * | First ()
CompatabilityListItem * | Last ()
virtual void | Parent (DisplayFrame *par)
DisplayFrame * | Parent () const
virtual const Vertex & | Location () const
virtual void | Location (const Vertex &v)
virtual void | Location (float x, float y, float z)
virtual void | Rotate (float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &origin, float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis)
virtual void | SetBlendColor (const GlsColor &color)
void | SetBlendColor (unsigned char color[])
void | SetBlendColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
void | GetBlendColor (unsigned char color[])
void | GetBlendColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
virtual GlsColor | GetBlendColor ()
virtual void | SetColor (const GlsColor &color)
void | SetColor (unsigned char c4[])
void | SetColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual GlsColor | GetColor ()
void | GetColor (unsigned char c4[])
void | GetColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
void | SetFillColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
void | SetFillColor (unsigned char c4[])
virtual void | SetFillColor (const GlsColor &color)
void | GetFillColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
void | GetFillColor (unsigned char c4[])
virtual GlsColor | GetFillColor ()
virtual bool | TextureRepeat ()
virtual void | TextureRepeat (const int rep)
Public Member Functions inherited from DisplayObject
| DisplayObject (float x, float y, float z)
| DisplayObject (const DisplayObject &object, const bool generateNames)
virtual | ~DisplayObject ()
void | Destroy ()
virtual void | SetAvailableAttributes (unsigned int value)
virtual void | AlphaMode (int mode)
virtual int | AlphaMode ()
virtual bool | AntiAlias ()
virtual void | AntiAlias (bool alias)
void | ApplyTextureSettings (int textureIndex=-1)
DistiAttribDict & | Attributes ()
const DistiAttribDict & | Attributes () const
virtual void | SetBlendColor (const GlsColor &color)
void | GetBlendColor (unsigned char color[])
void | GetBlendColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
virtual GlsColor | GetBlendColor ()
void | SetBlendColor (unsigned char color[])
void | SetBlendColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual bool | BlinkedOff ()
virtual bool | Blinking ()
virtual void | Blinking (const bool blink)
virtual float | BlinkRate ()
virtual void | BlinkRate (const float rate)
const Vector & | BoundingVolumeCenter () const
void | BoundingVolumeCenter (const Vector &center)
bool | BoundingVolumeHit (const Vector &start, const Vector &direction)
float | BoundingVolumeRadius () const
void | BoundingVolumeRadius (float radius)
virtual void | Calculate (double time)
void | CalculateCollisionPoint (const Vector &pickLoc, const Vector &directionVector, Vector *collisionPoint)
virtual void | CalculateParentBoundingBox ()
virtual void | CalculateTextureCoordinates ()
bool | GetTexturePointTransformationMatrix (GlsMatrixType &world2tex)
CallbackMethodCallerBase * | CallbackCaller () const
void | CallbackCaller (CallbackMethodCallerBase *cb)
virtual void | GetCenter (Vector &center)
virtual DisplayObject * | CloneObject (bool generateNames=false)=0
virtual GlsColor | GetColor ()
void | GetColor (unsigned char c4[])
void | GetColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
virtual void | SetColor (const GlsColor &color)
void | SetColor (unsigned char c4[])
void | SetColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
virtual void | CopyGeometry (DisplayObject *src)
virtual void | CopyHierarchyProperties (DisplayObject *src, bool copyName)
virtual void | CopyProperties (DisplayObject *src)
virtual void | CullBackFace (const bool val)
virtual bool | CullBackFace ()
bool | Culled () const
void | Culled (bool val)
bool | CullTest (const GlsMatrixType *matrix, const Culler &culler)
GlsMatrixType & | DcsMatrix ()
GlsMatrixType | DcsMatrix () const
void | DcsMatrix (const GlsMatrixType &matrix)
virtual void | DeleteVertexAt (unsigned int index)
virtual void | DeleteVertex (unsigned int indexAfter) final
virtual int | DepthTest ()
virtual void | DepthTest (unsigned char zbuf)
virtual void | Draw ()=0
const GlsMatrixType * | DrawMatrix ()
bool | NeedCalcDrawMatrix ()
void | DynamicRotate (float angle, int axis)
void | DynamicRotate (const Vector &v)
void | DynamicRotate (float angle[])
virtual void | DynamicRotate (float x, float y, float z)
virtual void | DynamicRotateRelative (float angle, int axis)
virtual float | DynamicRotation (int axis)
virtual Vector | DynamicRotation ()
virtual Vector | DynamicScale ()
virtual void | DynamicScale (float x, float y, float z)
void | DynamicScale (const Vector &scale)
virtual void | DynamicTranslate (float x, float y, float z, bool relative=false)
void | DynamicTranslate (const Vertex &amount, bool relative)
void | DynamicTranslate (const Vector &amount)
virtual void | DynamicTranslateAxis (float amount, int axis, bool relative)
virtual float | DynamicTranslation (int axis)
virtual Vector | DynamicTranslation ()
DisplayObjectEditor * | Editor ()
const DisplayObjectEditor * | Editor () const
void | Editor (DisplayObjectEditor *editor)
virtual void | GetExtents (float &x, float &y, float &z, float &x1, float &y1, float &z1)
void | GetExtentsDCS (Vector &min, Vector &max)
void | GetFillColor (unsigned char &r, unsigned char &g, unsigned char &b, unsigned char &a)
void | GetFillColor (unsigned char c4[])
virtual GlsColor | GetFillColor ()
void | SetFillColor (unsigned char r, unsigned char g, unsigned char b, unsigned char a)
void | SetFillColor (unsigned char c4[])
virtual void | SetFillColor (const GlsColor &color)
virtual void | FinishObject ()
virtual void | GenerateInstanceName ()
virtual DisplayObject * | handle (DisplayEvent *ev)
virtual bool | Hit (float x, float y, float z, float scale, const Vector &directionVector, Vector *collisionPoint)
virtual bool | HitUtil (float x, float y, float z, float scale, Vertex *vertices, unsigned int vertex_cnt, const Vector &directionVector, Vector *collisionPoint)
virtual void | InsertVertexAt (unsigned int index)
virtual void | InsertVertex (unsigned int indexAfter) final
char * | InstanceName ()
const char * | InstanceName () const
void | InstanceName (const char *name)
virtual bool | LightingEnabled ()
virtual void | LightingEnabled (bool lighting)
virtual int | LineStippleMultiplier ()
virtual void | LineStippleMultiplier (int mult)
virtual int | LineStipplePattern ()
virtual void | LineStipplePattern (int pattern)
virtual float | LineWidth ()
virtual void | LineWidth (float width)
virtual const Vertex & | Location () const
virtual void | Location (const Vertex &v)
virtual void | Location (float x, float y, float z)
virtual void | GetLocation (Vertex &v)
virtual void | GetLocation (float &x, float &y, float &z)
float | X () const
float | Y () const
float | Z () const
void | X (const float x)
void | Y (const float y)
void | Z (const float z)
virtual int | MaterialIndex ()
virtual void | MaterialIndex (int index)
virtual DynamicArray< int > & | MaterialIndices ()
virtual void | MaterialIndices (DynamicArray< int > indices)
GlsMatrixType * | ModelMatrix ()
bool | NeedCalculate ()
Vector * | Normals ()
virtual void | SetNormals (unsigned int nPoints, Vector *vertices)
void | VaSetNormals (unsigned int nPoints,...)
unsigned int | NumberOfVertices () const
virtual float | ObjectDepth ()
virtual float | ObjectHeight ()
virtual float | ObjectWidth ()
virtual void | SetOrigin (const Vertex &vert)
virtual void | Parent (DisplayFrame *par)
DisplayFrame * | Parent () const
virtual void | ParentGroup (Group *group)
Group * | ParentGroup () const
virtual DisplayObject * | Pick3D (const Vector &winLoc, const Vector &logicalCoords, float scale, const Vector &directionVector, Vector &collisionWinLoc, const OpenGLMatrices &drawnMatrices)
unsigned char | Pickable ()
virtual void | Pickable (unsigned char pick)
virtual int | PolygonEnd ()
virtual void | PolygonEnd (const int end)
virtual int | PolygonMode ()
virtual void | PolygonMode (int mode)
virtual void | PreDraw (const OpenGLMatrices &current, Culler &culler)
GlsMatrixType * | ProjMatrix ()
virtual void | ReallocateVertices (unsigned int numVertices, bool initializeNew, bool copyOld)
virtual float | RelativeAngle (const float x, const float y)
virtual DistiAttributeBase & | Resource (const char *name)
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL)
const Vertex & | RotationPoint () const
virtual void | RotationPoint (const Vertex &v)
virtual void | RotationPoint (float x, float y, float z)
virtual void | GetRotationPoint (Vertex &v)
virtual void | Rotate (float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &origin, float angle, int axis=Z_AXIS)
virtual void | Rotate (const Vector &orig, float angle, const Vector &axis)
void | SaveMatrices ()
virtual void | Scale (float px, float py, float pz, Vertex *anchor, int handleBar=0)
void | Set (int spec,...)
bool | SetupAlpha ()
void | SetupDepthTest ()
void | SetupLighting ()
bool | SetupLineStyle ()
bool | SetupTexture ()
virtual int | Shading ()
virtual void | Shading (const int shading)
virtual void | GetTransformedExtents (Vector &min, Vector &max, const GlsMatrixType &matrix, bool resetMinMax=true)
virtual void | SetTexCoords (unsigned int nPoints, Vector *new_tex_coord, bool isVectorArray=true)
void | SetTexCoords (unsigned int nPoints, Vertex *new_tex_coord)
void | VaSetTexCoords (unsigned int nPoints,...)
Vector * | TextureCoordinates ()
Vector * | GetTextureCoordinates ()
virtual int | TextureIndex ()
virtual void | TextureIndex (int textureIndex)
virtual Vector * | GetTexturePoints ()
virtual bool | TextureRepeat ()
virtual void | TextureRepeat (const int rep)
virtual int | TextureMappingTechnique ()
virtual void | TextureMappingTechnique (const int map)
virtual int | TextureMagnificationFilter ()
virtual void | TextureMagnificationFilter (const int filter)
virtual int | TextureMinificationFilter ()
virtual void | TextureMinificationFilter (const int filter)
virtual void | Translate (float tr[])
virtual void | Translate (float x, float y, float z)
virtual void | TranslateVertices (float x, float y, float z)
virtual void | UpdateBoundingVolume ()
void * | UserData () const
void | UserData (void *data)
virtual void | SetVertexColor (unsigned int vertex, unsigned char CurrentFillColor[])
virtual Vertex * | Vertices ()
virtual void | SetVertices (unsigned int nPoints, Vertex *vertices)
void | VaSetVertices (unsigned int nPoints,...)
int * | ViewMatrix ()
bool | Visible () const
bool | Visibility () const
virtual void | Visibility (const bool vis)
virtual Vector | WorldRotationPoint ()
virtual void | WorldRotationPoint (const Vector &vert)
virtual Vertex | WorldVertex (unsigned int i)
virtual void | WorldVertex (unsigned int i, const Vertex &vert)
bool | LogicalToWindow (const Vector &logical, Vector &winLoc, const OpenGLMatrices &alternateMatrices=OpenGLMatrices())
bool | WindowToLogical (const Vector &winLoc, Vector &logical, Vector *directionVector=NULL, const OpenGLMatrices &alternateMatrices=OpenGLMatrices())
void | LogicalToDCS (Vector logicalPoint, Vector &objectLocal, const Vector *directionVector, const Vector &planeNormal=Vector(0, 0, 1), const Vector &planePoint=Vector(), const GlsMatrixType *dcsMatrix=NULL)
void | DCSToLogical (Vector dcsPoint, Vector &logicalPoint, const GlsMatrixType *dcsMatrix=NULL)
bool | Create (GlsGloFile &dataStream, Group *parent)
void | GeometryRefresh ()
| Invalidates the painter and refreshes the geometry on the next paint cycle.
virtual bool | GetPlaneVectorPoints (Vertex &p1, Vertex &p2, Vertex &p3, Vertex &planeVector)
void | NotifyAttributeChanged (const AttributeName &name) override
virtual void | SetPainter (GlsPainter *painter)
virtual GlsPainter * | GetPainter ()
void | InvalidatePainter ()
virtual bool | IsVisibleInScene (const DisplayObject *obj=NULL) const
Public Member Functions inherited from AttributeChangedNotifier
virtual void | NotifyAttributeChanged (const AttributeName &name)=0
virtual | ~AttributeChangedNotifier ()
Public Member Functions inherited from WeakReferenceableMixin
void | AddWeakReference (WeakReference *weakRef) override
void | NotifyWeakReferenceDestroyed (WeakReference *ref) override
virtual void | AddWeakReference (WeakReference *weakRef)=0
virtual void | NotifyWeakReferenceDestroyed (WeakReference *weakReference)=0
Public Member Functions inherited from DisplayFrame
| DisplayFrame (int width, int height, bool allocateObjects=true)
void | ClearBitfield (GLbitfield bitField)
GLbitfield | ClearBitfield ()
virtual void | DragObject (DisplayObject *obj)
virtual DisplayObject * | DragObject ()
virtual void | ClearDrag ()
virtual void | FocusObject (DisplayObject *obj)
virtual DisplayObject * | FocusObject ()
virtual void | ClearFocus ()
virtual void | MultitouchEnabled (bool enabled)
virtual bool | MultitouchEnabled ()
virtual InputHandler * | GetInputHandler ()
virtual DisplayObject * | HandleDisplayEvent (DisplayEvent *ev)
virtual void | WriteResources (const char *filename, GlsResourceFilter *filter=NULL)
virtual void | ReadResources (const char *filename)
virtual DistiAttributeBase & | Resource (const char *name)
virtual void | GetResources (std::ostream &outstr, GlsResourceFilter *filter=NULL)
virtual void | SetResources (std::istream &instr)
void | SetResource (const std::string &resourceName, const std::string &resourceVal)
void | SetResource (const char *resourceName, const char *resourceVal)
std::string | GetResource (const std::string &resourceName)
std::string | GetResource (const char *resourceName)
virtual char * | GetResource_CRTClean (const char *name)
virtual void | GetResourceFree_CRTClean (char *memoryToFree)
virtual char * | GetResources_CRTClean (GlsResourceFilter *filter)
virtual void | GetResourcesFree_CRTClean (char *memoryToFree)
virtual void | SetResource_CRTClean (const char *name, const char *value)
virtual void | SetResources_CRTClean (const char *buf)
virtual void | NotifyAttributeChanged (const AttributeName &name) override
void | SetTexturePaletteSize (int cnt)
void | Draw ()
void | InsertObject (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=-1)
void | InsertObject (DisplayObject *obj, int loc)
void | PushObject (DisplayObject *obj)
int | Width ()
int | Height ()
void | SetWidth (int w)
void | SetHeight (int h)
virtual void | SetRedraw ()
bool | CullingEnabled ()
void | CullingEnabled (const bool enabled)
DistiAttribDict & | FrameAttribDict ()
const DistiAttribDict & | FrameAttribDict () const
DynamicMaterialArray & | MaterialPalette ()
ComponentLightMgr * | LightMgr ()
void | LightMgr (ComponentLightMgr *val)
virtual void | ClearDragAndFocus ()

## Static Public Member Functions
static GlsRSOWrapper * | CreateInstance (RsoImplBaseInterface *rso, unsigned int RSOVersion)
Static Public Member Functions inherited from ComponentBase
static ComponentBase * | CreateLiveComponent (const char *fileName=NULL, const char *className=NULL, bool performCreate=true, const GlsBuiltVersionInfo &callingVersion=GlsBuiltVersionInfo())
static bool | CheckLiveVersion (ComponentBase *comp, const GlsBuiltVersionInfo &callingVersion=GlsBuiltVersionInfo())
template<class T >
static T * | CreateComponent (DisplayObject::AvailableAttributesEnum availableAttributes=DisplayObject::GLS_ATTRIBUTES_ALL)
Static Public Member Functions inherited from Group
static DisplayObject * | CreateInstance ()
Static Public Member Functions inherited from DisplayObject
static void | UseManualBlinkElapsedTime (bool useManualTime)
static void | SetManualBlinkElapsedTime (double elapsedTime)
Static Public Member Functions inherited from DisplayFrame
static void | SetOpenGLDefaultState (bool saveVal)
static void | RestoreOpenGLState ()

## Protected Types
enum | MultitouchState { READY_FOR_INPUT , PROCESSING_MOUSE_DRAG , WAITING_FOR_MOUSE_DOWN }

## Protected Member Functions
void | LastEmittedEventInitiatorName (const char *name)
virtual DisplayObject * | HandleMultiTouchInput (MouseEvent *mev)
Protected Member Functions inherited from ComponentBase
virtual void | CalcDrawMatrix () override
virtual void | CalculateMatrices (const OpenGLMatrices &newMatrices) override
void | EditorTransformMatrix (const GlsMatrixType &matrix)
const GlsMatrixType & | EditorTransformMatrix () const
virtual void | SetFromGloData (GlsGloFileAttribute &data) override
Protected Member Functions inherited from Group
virtual void | AddAvailableAttributes (unsigned int availableAttributes)
virtual void | GrowBoundingBox (DisplayObject *obj)
Protected Member Functions inherited from DisplayObject
virtual void | VaListSetVertices (unsigned int nPoints, va_list args)
virtual void | VaListSetNormals (unsigned int nPoints, va_list args)
virtual void | VaListSetTexCoords (unsigned int nPoints, va_list args)
void | ApplyTextureMinMagSettings ()
| Updates the state manager's texture minification and magnification filter based on this display's configuration.
void | ApplyTextureEnvModeSettings ()
| Updates the state manager's texture environment based on this object configuration.
bool | SetupTextureIsNeeded ()
virtual int | ColorMaterialMode ()
void | AllocateModelMatrix ()
bool | ApplyDynamicRotation ()
virtual void | CalcDrawMatrix ()
void | CalcDrawMatrixIfExists ()
virtual void | CalculateMatrices (const OpenGLMatrices &newMatrices)
bool | InsideVertexExtents (float x, float y, unsigned int nVerts, Vertex *verts, float tolerance)
void | LastDrawMatrixLocation (const Vertex &loc)
const Vertex & | LastDrawMatrixLocation ()
void | NeedCalculate (bool val)
void | PickSetup (float x, float y, float z, Vertex *vertices, unsigned int vertex_cnt, const Vector &directionVector)
void | PickCleanup (Vertex *vertices, unsigned int vertex_cnt)
virtual void | SetFromGloData (GlsGloFileAttribute &data)
virtual void | SetValue (int spec, va_list &args)
int | GetApplicableTextureIndex ()
int | GetApplicableTextureRepeat ()
Protected Member Functions inherited from WeakReferenceableMixin
| WeakReferenceableMixin ()
virtual | ~WeakReferenceableMixin ()
Protected Member Functions inherited from DisplayFrame
virtual void | CurrentCursor (unsigned int cursor_id)
void | CleanupDragMap ()
DisplayObject * | GetDragObjectForCursor (unsigned int cursorID)
DisplayObject * | FindDragObject ()
virtual EventCompressor< DisplayFrame > * | GetEventCompressor ()
virtual float | Scale ()

## Protected Attributes
RsoImplBaseInterface * | _rsoInterface
| The RSO being wrapped by this interface.
AttributeWrapperMap * | _attributeWrapperMap
| A map of attributes that wrap to the attributes within the RSO.
EmittedEventHandlerImpl * | _rsoEmittedEventHandler
| The event handler for the RSO.
char * | _lastEmittedEventInitiatorName
| The name of the last object who emitted an event that made it to the event handler.
MultitouchState | _multitouchState
| The current multitouch input state,. More...
unsigned int | _currentCursor
| The cursor id of the current mouse / touch interacting with the RSO.
unsigned int | _rsoVersion
| The interface version of the wrapped RSO.
Protected Attributes inherited from ComponentBase
LiveComponentAccessor * | _liveAccessor
bool | _absolutePlacement
Vertex | _absolutePlacementDelta
| The delta vector used when using relative placement.
DisplayFrame * | _parentDisplayFrame
GlsMatrixType | _editorTransformMatrix
Protected Attributes inherited from Group
DisplayObjectArray | _objects
| The objects contained in this group.
Protected Attributes inherited from DisplayObject
bool | _geometryRefresh
| Whether or not the geometry (VBOs etc.) needs to be updated on the GPU.
int | _alphaMode
bool | _antiAlias
bool | _attributesAdded
bool | _blinking
float | _blinkRate
bool | _isBlinkedOff
| Stores whether the object is presently blinked on or off.
GlsColor | _color
bool | _cullBackFace
GlsMatrixType | _dcsMatrix
unsigned char | _depthTest
GlsMatrixType * | _drawMatrix
bool | _needCalcDrawMatrix
| True if CalcDrawMatrix() needs to be called on this object.
unsigned char | _lineStippleMultiplier
unsigned short | _lineStipplePattern
float | _lineWidth
Vertex | _location
DynamicArray< int > | _materialIndices
| List of materials associated with this object.
GlsMatrixType * | _modelMatrix
Vector * | _normals
unsigned int | _nTex_vertices
unsigned int | _nVertices
unsigned char | _polygonEnd
unsigned char | _polygonMode
GlsMatrixType * | _projMatrix
unsigned char | _shading
Vector * | _texCoord
GlsColor | _textureBlendColor
int | _textureIndex
unsigned char | _textureMagFilter
unsigned char | _textureMinFilter
unsigned char | _textureMap
Vector | _texturePoints [4]
unsigned char | _textureRepeat
void * | _userData
Vertex * | _vertices
int * | _viewMatrix
bool | _visible
IGlsStateManager * | _stateManager
| The state manager that interfaces with OpenGL and maintains its render state.
Protected Attributes inherited from WeakReferenceableMixin
DynamicArray< WeakReference * > * | _weakRefs
Protected Attributes inherited from DisplayFrame
bool | _cullingEnabled
int | _width
int | _height
float | _lastPickedDepth
DynamicMaterialArray | _materialPalette
ComponentLightMgr * | _lightMgr
GLbitfield | _clearBitfield
std::string | _componentHeaderFileName
DragObjectMap * | _dragObjectMap
| Holds a focus object for each cursor.
unsigned int | _currentCursor
bool | _multitouchEnabled
unsigned int | _cursorsDown

## Additional Inherited Members
Public Attributes inherited from Group
DynamicArray< CompatabilityListItem > | _compatList
| Used for GL Studio 2.1 compatibility only.
Public Attributes inherited from DisplayFrame
TexturePalette * | texturePalette
SoundSystem * | _sound_player
Group * | objects

## Detailed Description

The GlsRSOWrapper class wraps an RsoImplBaseInterface object so that it can be inserted into the GL Studio heirarchy.

## Member Enumeration Documentation

## ◆ MultitouchState

enum MultitouchState
| protected

enum that guides the state machine for multitouch handling for RSO's that don't support multitouch.
An RSO starts in the READY_FOR_INPUT state. When it handles a mouse drag event, it moves to PROCESSING_MOUSE_DRAG state. It will ignore any other mouse events if they are not for the original cursor_id. Then, once the RSO either receives the MOUSE_UP event or stops handling the MOUSE_DRAG events, the RSO then transitions to WAITING_FOR_MOUSE_DOWN (i.e. it keeps ignoring other cursors that might have been dragging on it while it was processing its original cursor event). Once it receives a new mouse down, it transitions back to READY_FOR_INPUT

## Constructor & Destructor Documentation

## ◆ GlsRSOWrapper()

GlsRSOWrapper | ( | RsoImplBaseInterface * | rso,
|  | unsigned int | RSOVersion
| ) |  |

Constructor

Parameters

  rso | The RSO to wrap.
  RSOVersion | The highest RSOInterface the RSO supports (e.g. 1,2,3).

## ◆ ~GlsRSOWrapper()

virtual ~GlsRSOWrapper | ( |  | ) |
| virtual

Destructor Don't call "delete yourComponent;", instead call "yourComponent->Destroy();" to ensure that the object is deleted correctly.

## Member Function Documentation

## ◆ AbsolutePlacement()

virtual void AbsolutePlacement | ( | bool | val | ) |
| override virtual

Sets the value for Absolute Placement. This affects what happens during the call to CreateObjects().

Parameters

  val | If true, the component will be left in the generated location, otherwise it will be moved based on its extents.

Reimplemented from ComponentBase.

## ◆ AlphaMode() [1/2]

virtual int AlphaMode | ( |  | ) |
| override virtual

Get the alpha mode for this object

Returns
  Whether or not alpha testing or blending is enabled when drawing

See also
  AlphaMode_e

Reimplemented from Group.

## ◆ AlphaMode() [2/2]

virtual void AlphaMode | ( | int | mode | ) |
| override virtual

Set the alpha mode state for this object

Parameters

  mode | which alpha mode to use when drawing

See also
  AlphaMode_e

Reimplemented from Group.

## ◆ AntiAlias() [1/2]

virtual bool AntiAlias | ( |  | ) |
| override virtual

Get the anti aliasing state this object

Returns
  Whether or not this object will be drawn antialiased

Reimplemented from Group.

## ◆ AntiAlias() [2/2]

virtual void AntiAlias | ( | bool | alias | ) |
| override virtual

Set the anti aliasing state for this object

Parameters

  alias | Whether or not to perform anti aliasing

Reimplemented from Group.

## ◆ Calculate()

virtual void Calculate | ( | double | time | ) |
| override virtual

Provides a mechanism for performing regular calculations, seperate from drawing. In a standalone applicaton Calculate is recursively called by the main loop before the objects are drawn.

Parameters

  time | The elaspsed time in seconds since program start

Reimplemented from Group.

## ◆ CalculateBoundingBox()

virtual void CalculateBoundingBox | ( |  | ) |
| override virtual

Recalculates the 3D bounding volume of the object, setting the Group's vertices. Affects the results of GetExtents(). This should be called when a Group's children are modified.

Reimplemented from ComponentBase.

## ◆ ChangeRSO()

void ChangeRSO | ( | RsoImplBaseInterface * | rso,
|  | bool | deleteCurrent = `true`
| ) |  |

Replace the RSO that the GlsRSOWrapper is wrapping.

Parameters

  rso | The new RSO to use
  deleteCurrent | Whether to delete the currently referenced rso. If false, then the caller is responsible for deleting it.

## ◆ CloneObject()

virtual DisplayObject * CloneObject | ( | bool | generateNames = `false` | ) |
| override virtual

Copy+Create operation in one method. In derived classes, this method will create a new instance of the derived class and then copy the object into the new instance. The cut,copy,paste and undo operations use this method.

Parameters

  generateNames | Whether or not to generate new names for cloned objects

Returns
  A new object, identical to the original, except for the instance name

Reimplemented from ComponentBase.

## ◆ CopyGeometry()

virtual void CopyGeometry | ( | DisplayObject * | src | ) |
| override virtual

Copies the geometry information from one object to another. Used by the undo mechanism to allow user to undo a geometry change.

Parameters

  src | The object to copy geometry from

Reimplemented from ComponentBase.

## ◆ CopyProperties()

virtual void CopyProperties | ( | DisplayObject * | src | ) |
| override virtual

Copies the attributes except for geometry attributes from one object to another. Used by the undo mechanism to undo most attribute change operations.

Parameters

  src | The object to copy properties from

Reimplemented from ComponentBase.

## ◆ CreateInstance()

static GlsRSOWrapper * CreateInstance | ( | RsoImplBaseInterface * | rso,
|  | unsigned int | RSOVersion
| ) |  |
| static

Call CreateInstance() and Destroy() instead of new and delete in a mixed-library environment to ensure that matching new and delete operators are called.

Parameters

  rso | The RSO to wrap.
  RSOVersion | The highest RSOInterface the RSO supports (e.g. 1,2,3).

Returns
  A pointer to a new GlsRSOWrapper object.

## ◆ CreateObjects()

virtual void CreateObjects | ( |  | ) |
| override virtual

In derived classes this creates all the geometry for the component

Reimplemented from ComponentBase.

## ◆ CullBackFace() [1/2]

virtual bool CullBackFace | ( |  | ) |
| override virtual

Returns if back faces should be removed

Returns
  True if backfaces are removed

Reimplemented from Group.

## ◆ CullBackFace() [2/2]

virtual void CullBackFace | ( | const bool | val | ) |
| override virtual

Sets if back faces should be removed

Parameters

  val | True if back faces should be removed

Reimplemented from Group.

## ◆ DeleteInstance()

virtual void DeleteInstance | ( |  | ) |
| virtual

Utility Method: Users should call Destroy() instead. Safely delete an object that was created using CreateInstance.

## ◆ DepthTest() [1/2]

virtual int DepthTest | ( |  | ) |
| override virtual

Get the z buffering state for this object

Returns
  Whether or not this object will be draw Z buffered

Reimplemented from Group.

## ◆ DepthTest() [2/2]

virtual void DepthTest | ( | unsigned char | zbuf | ) |
| override virtual

Set the z buffering state for this object

Parameters

  zbuf | Whether or not to perform z buffering

Reimplemented from Group.

## ◆ Draw()

virtual void Draw | ( |  | ) |
| override virtual

Draws this object on the current display frame (_parent member). Pure virtual method

Reimplemented from ComponentBase.

## ◆ GetBlendColor()

virtual GlsColor GetBlendColor | ( |  | ) |
| override virtual

Gets the texture blend color for the object

Returns
  Returns the current texture blend color.

Reimplemented from Group.

## ◆ GetColor()

virtual GlsColor GetColor | ( |  | ) |
| override virtual

Gets the color for the object outline

Returns
  The outline color

Reimplemented from Group.

## ◆ GetExtents()

virtual void GetExtents | ( | float & | x,
|  | float & | y,
|  | float & | z,
|  | float & | x1,
|  | float & | y1,
|  | float & | z1
| ) |  |
| override virtual

Figure out the static extents for the object. Used by the editor as part of the pick operation and for figuring out the size of groups.

Parameters

  x | Gets the minimum x extent
  y | Gets the minimum y extent
  z | Gets the minimum z extent
  x1 | Gets the maximum x extent
  y1 | Gets the maximum y extent
  z1 | Gets the maximum z extent

Reimplemented from ComponentBase.

## ◆ GetResources()

virtual void GetResources | ( | std::ostream & | outstr,
|  | GlsResourceFilter * | filter = `NULL`
| ) |  |
| override virtual

Writes the resources (attributes) of this object to the specified stream. The output of this method can be controlled by the GlsResourceFilter. Note that if filter->NamesOnly() is false (the default), then only resources that can return a value will appear in the list.

See also
  GlsResourceFilter
  DistiAttributeProperty

Parameters

  outstr | The stream to write to
  filter | The filter to determine what to write

Reimplemented from ComponentBase.

## ◆ GetRSOVersion()

unsigned int GetRSOVersion | ( |  | ) | const
| inline

Returns
  The rso version.

## ◆ GetTransformedExtents()

virtual void GetTransformedExtents | ( | Vector & | min,
|  | Vector & | max,
|  | const GlsMatrixType & | matrix,
|  | bool | resetMinMax = `true`
| ) |  |
| override virtual

Determines the static extents of the geometry projected to the XY plane of an arbirary coordinate system.

Parameters

  min | Returns the minimum values found in the traversal
  max | Returns the maximum values found in the traversal
  matrix | Transformation matrix from logical coordinates to the coordinate system to determine the extents in.
  resetMinMax | Normally not specified by user. Should be true for the initial call.

Reimplemented from ComponentBase.

## ◆ handle()

virtual DisplayObject * handle | ( | DisplayEvent * | ev | ) |
| override virtual

Handles an event that is sent to the object.

Parameters

  ev | The event to send to the object

Returns
  Which object handled the event

Reimplemented from DisplayObject.

## ◆ HandleEmittedEvent()

int HandleEmittedEvent | ( | RsoImplBaseInterface::Event * | ev | ) |

Handle an event that was emitted from the RSO.

Parameters

  ev | The event to handle.

Returns
  Non-zero if the event was handled, otherwise zero.

## ◆ HandleInput()

virtual DisplayObject * HandleInput | ( | DisplayEvent * | ev | ) |
| override virtual

Handles input events.
It traverses the hierarchy with Pick3D.
Then THE picked object is given the handle() call.

Parameters

  ev | The event data.

Returns
  The object that handled the input.

Reimplemented from ComponentBase.

## ◆ HandleMultiTouchInput()

virtual DisplayObject * HandleMultiTouchInput | ( | MouseEvent * | mev | ) |
| protected virtual

This function should be called to handle mouse events if the RSO handles multitouch (RSO version 3 or greater).

Note
  Not normally called by users.

Parameters

  mev | The event to handle.

Returns
  A pointer to the object that received the event, or NULL.

## ◆ Init()

virtual void Init | ( |  | ) |
| override virtual

Peforms post creation tasks including reparenting all objects. and adjusting their position. It checks the value of _absolutePlacement to determine if movement of the generated objects is necessary /see AbsolutePlacement

Reimplemented from ComponentBase.

## ◆ Initialize()

virtual void Initialize | ( |  | ) |
| override virtual

The GL Studio code generator allways derives a new Initialize method for the user This is called after all the objects are created.

Reimplemented from ComponentBase.

## ◆ LastEmittedEventInitiatorName() [1/2]

const char * LastEmittedEventInitiatorName | ( |  | ) | const

Returns
  The qualified instance name of the initiator of the last event that was passed to HandleEmittedEvent or "" if no events have been passed to HandleEmittedEvent.

## ◆ LastEmittedEventInitiatorName() [2/2]

void LastEmittedEventInitiatorName | ( | const char * | name | ) |
| protected

Set the name of the object who most recently emitted an event that was handled by the event handler.

Note
  Not normally called by users.

Parameters

  name | The new object name to set.

## ◆ LightingEnabled() [1/2]

virtual bool LightingEnabled | ( |  | ) |
| override virtual

Returns
  The current lighting state.

Reimplemented from Group.

## ◆ LightingEnabled() [2/2]

virtual void LightingEnabled | ( | bool | lighting | ) |
| override virtual

Sets the lighting state.

Parameters

  lighting | The new lighting state.

Reimplemented from Group.

## ◆ LineStippleMultiplier() [1/2]

virtual int LineStippleMultiplier | ( |  | ) |
| override virtual

Get the line stipple multiplier for this object

Returns
  The line stipple multiplier for this object

Reimplemented from Group.

## ◆ LineStippleMultiplier() [2/2]

virtual void LineStippleMultiplier | ( | int | mult | ) |
| override virtual

Set the line stipple multiplier for this object

Parameters

  mult | The new line stipple pattern

Reimplemented from Group.

## ◆ LineStipplePattern() [1/2]

virtual int LineStipplePattern | ( |  | ) |
| override virtual

Get the line stipple pattern for this object

Returns
  The line stipple pattern for this object

Reimplemented from Group.

## ◆ LineStipplePattern() [2/2]

virtual void LineStipplePattern | ( | int | pattern | ) |
| override virtual

Set the line stipple pattern for this object

Parameters

  pattern | The new line stipple pattern

Reimplemented from Group.

## ◆ LineWidth() [1/2]

virtual float LineWidth | ( |  | ) |
| override virtual

Gets the width of lines in the object.

Returns
  The line width of the object in logical units

Reimplemented from Group.

## ◆ LineWidth() [2/2]

virtual void LineWidth | ( | float | width | ) |
| override virtual

Sets the width of lines in the object.

Parameters

  width | The new line width of the object in logical units

Reimplemented from Group.

## ◆ MaterialIndex() [1/2]

virtual int MaterialIndex | ( |  | ) |
| override virtual

Returns
  The current material index. Returns -1 if multiple are applied.

Reimplemented from DisplayObject.

## ◆ MaterialIndex() [2/2]

virtual void MaterialIndex | ( | int | index | ) |
| override virtual

Sets the material index.

Parameters

  index | The new material index to set.

Reimplemented from DisplayObject.

## ◆ Pick3D()

virtual DisplayObject * Pick3D | ( | const Vector & | winLoc,
|  | const Vector & | logicalCoords,
|  | float | scale,
|  | const Vector & | directionVector,
|  | Vector & | collisionWinLoc,
|  | const OpenGLMatrices & | drawnMatrices
| ) |  |
| override virtual

Attempts to pick an object in 3D and accounting for dynamic rotations and translations of this object or parent objects. It also looks at the pickable status and attempts to return the "Best" pick if that is what is desired.

Note: This method will pick objects in the scene based on a pick ray starting at winLoc and pointing into the screen. It will not pick objects behind the depth specified by winLoc.z. Typically winLoc.z should be set to 0 to ensure that the pick ray starts at near clip plane.

Parameters

  winLoc | Device coordinates for the mouse click. Z value should be set to 0 to ensure pick ray starts at near clip plane.
  logicalCoords | The start of the pick ray in logical coordinates. Should be calculated from the winLoc using this->WindowToLogical(winLoc, logicalCoords, &directionVector).
  scale | Current window scale. Affects picking radius of outlines. Initial value should typically be 1.0.
  directionVector | The direction of the pick ray in logical coordinates. Should be calculated from the winLoc using this->WindowToLogical(winLoc, logicalCoords, &directionVector).
  collisionWinLoc | Returns where the pick vector intersects the object that is hit in device coordinates.
  drawnMatrices | The matrices used to draw the object, including matrices set by parents that may have dynamically rotated, translated or scaled this object. Initial value should typically be a default OpenGLMatrices() object.

Returns
  The object that was hit, or NULL if no object hit

Reimplemented from ComponentBase.

## ◆ PolygonEnd() [1/2]

virtual int PolygonEnd | ( |  | ) |
| override virtual

Gets the polygon end mode (Open or Closed) for the polygon

Returns
  Enumeration indicating open or closed mode

See also
  PolygonClose_e

Reimplemented from Group.

## ◆ PolygonEnd() [2/2]

virtual void PolygonEnd | ( | const int | end | ) |
| override virtual

Sets the polygon end mode (Open or Closed) for the polygon

Parameters

  end | Enumeration indicating open or closed mode

See also
  PolygonClose_e

Reimplemented from Group.

## ◆ PolygonMode() [1/2]

virtual int PolygonMode | ( |  | ) |
| override virtual

Gets the polygon drawing mode for this object

Returns
  The polygon drawing mode for this object

See also
  PolygonMode_e

Reimplemented from Group.

## ◆ PolygonMode() [2/2]

virtual void PolygonMode | ( | int | mode | ) |
| override virtual

Sets the polygon drawing mode for this object

Parameters

  mode | The new polygon drawing mode for this object

See also
  PolygonMode_e

Reimplemented from Group.

## ◆ PreDraw()

virtual void PreDraw | ( | const OpenGLMatrices & | current,
|  | Culler & | culler
| ) |  |
| override virtual

Traverses the hierarchy calculating the _modelMatrix, _projMatrix, _viewMatrix as needed.

Parameters

  current | Current matrices inherited from parent
  culler | Object that possibly marks this object for culling

Reimplemented from ComponentBase.

## ◆ Resource()

virtual DistiAttributeBase & Resource | ( | const char * | name | ) |
| override virtual

Gets a reference to the specified attribute for reading and writing. This reference can be streamed into and out of variables. For Example: someObject->Resource("Visible") >> someBool; someBool << someObject->Resource("Visible");

Parameters

  name | The name of the attribute to be returned.

Returns
  A reference to the attribute if it is present, or DistiEmptyAttribute if not.

Reimplemented from ComponentBase.

## ◆ Rotate() [1/2]

virtual void Rotate | ( | const Vector & | orig,
|  | float | angle,
|  | const Vector & | axis
| ) |  |
| override virtual

Rotates the object (around the specified axis) by the angle indicated, at the point specified. Recalculates the vertex data.

Parameters

  orig | The point to rotate around
  angle | The angle to rotate by, in degrees
  axis | The arbitrary axis to rotate the object around

Reimplemented from ComponentBase.

## ◆ Rotate() [2/2]

virtual void Rotate | ( | const Vector & | orig,
|  | float | angle,
|  | const Vector & | axis
| ) |  |
| override virtual

Rotates the object (around the specified axis) by the angle indicated, at the point specified. Recalculates the vertex data.

Parameters

  orig | The point to rotate around
  angle | The angle to rotate by, in degrees
  axis | The arbitrary axis to rotate the object around

Reimplemented from ComponentBase.

## ◆ RSOInterface()

RsoImplBaseInterface * RSOInterface | ( |  | ) |

Returns
  The current RSOInterface object.

## ◆ Scale() [1/3]

virtual void Scale | ( | float | px,
|  | float | py,
|  | float | pz,
|  | Vertex * | anchor,
|  | int | handleBar = `0`
| ) |  |
| override virtual

Scales the object, either the handleBar, or the Anchor is used to translate the object, not both. Anchor takes presidence, if it is set HandleBar is ignored. The footprint is different from the 2D scale so the compiler can destinguish the two.

Parameters

  px | Value of the percentage of scale in x-axis
  py | Value of the percentage of scale in y-axis
  pz | Value of the percentage of scale in z-axis
  anchor | Anchor from which to scale object relative to
  handleBar | Vertex that is being dragged

Reimplemented from ComponentBase.

## ◆ Scale() [2/3]

virtual void Scale | ( | float | scale_x,
|  | float | scale_y
| ) |  |
| virtual

Scale in X-Y plane using the center of the group as the anchor.

Parameters

  scale_x | The X factor to scale by.
  scale_y | The Y factor to scale by.

Reimplemented from ComponentBase.

## ◆ Scale() [3/3]

void Scale | ( | float | px,
|  | float | py,
|  | float | pz,
|  | Vertex * | anchor = `NULL`,
|  | int | handleBar = `0`
| ) |  |
| override virtual

Scales the object, either the handleBar, or the Anchor is used to translate the object, not both. Anchor takes presidence, if it is set HandleBar is ignored. The footprint is different from the 2D scale so the compiler can destinguish the two.

Parameters

  px | Value of the percentage of scale in x-axis
  py | Value of the percentage of scale in y-axis
  pz | Value of the percentage of scale in z-axis
  anchor | Anchor from which to scale object relative to
  handleBar | Vertex that is being dragged

Reimplemented from ComponentBase.

## ◆ SetBlendColor()

virtual void SetBlendColor | ( | const GlsColor & | color | ) |
| override virtual

Sets the texture blend color for the object

Parameters

  color | A GlsColor

Reimplemented from Group.

## ◆ SetColor()

virtual void SetColor | ( | const GlsColor & | color | ) |
| override virtual

Sets the RGBA color for the object outline

Parameters

  color | The new color

Reimplemented from Group.

## ◆ SetPainter()

virtual void SetPainter | ( | GlsPainter * | painter | ) |
| override virtual

Sets the painter for this object. Can be NULL. If the painter is set, this object will call Invalidate() on the painter anytime it changes in a way that affects its rendering.

Note
  This object only observers the painter, and does not delete it.

Parameters

  painter | the painter that is drawing this class.

Reimplemented from DisplayObject.

## ◆ SetValue()

void SetValue | ( | int | spec,
|  | va_list & | args
| ) |  |
| override virtual

Sets an attribute of this object using variable arguments

Parameters

  spec | A GLS_Initializer tag
  args | A variable argument list

Reimplemented from ComponentBase.

## ◆ Shading() [1/2]

virtual int Shading | ( |  | ) |
| override virtual

Gets the polygon shading mode (Flat or gouraud) for the polygon

Returns
  Enumeration indicating shading mode

See also
  ShadingType_e

Reimplemented from Group.

## ◆ Shading() [2/2]

virtual void Shading | ( | const int | shading | ) |
| override virtual

Sets the polygon shading mode (Flat or gouraud) for the polygon

Parameters

  shading | Enumeration indicating shading mode

See also
  ShadingType_e

Reimplemented from Group.

## ◆ TextureIndex() [1/2]

virtual int TextureIndex | ( |  | ) |
| override virtual

Get the texture index for this object

Returns
  The texture index for this object

Reimplemented from ComponentBase.

## ◆ TextureIndex() [2/2]

virtual void TextureIndex | ( | int | textureIndex | ) |
| override virtual

Sets the texture index to be used when drawing the object.

Parameters

  textureIndex | The texture index to use. -1 indicates that no texture will be drawn.

Reimplemented from ComponentBase.

## ◆ TextureMagnificationFilter() [1/2]

virtual int TextureMagnificationFilter | ( |  | ) |
| override virtual

Gets the texture magnification filter for this object

Returns
  The texture magnification filter for this object

See also
  TextureFilter_e

Reimplemented from Group.

## ◆ TextureMagnificationFilter() [2/2]

virtual void TextureMagnificationFilter | ( | const int | filter | ) |
| override virtual

Sets the texture magnification filter for this object

Parameters

  filter | The new texture magnification filter for this object

See also
  TextureFilter_e

Reimplemented from Group.

## ◆ TextureMappingTechnique() [1/2]

virtual int TextureMappingTechnique | ( |  | ) |
| override virtual

Gets the texturing mapping mode for this object

Returns
  The texture mapping mode for this object

See also
  TextureMap_e

Reimplemented from Group.

## ◆ TextureMappingTechnique() [2/2]

virtual void TextureMappingTechnique | ( | const int | map | ) |
| override virtual

Sets the texturing mapping mode for this object

Parameters

  map | The new texture mapping mode for this object

See also
  TextureMap_e

Reimplemented from Group.

## ◆ TextureMinificationFilter() [1/2]

virtual int TextureMinificationFilter | ( |  | ) |
| override virtual

Gets the texture minification filter for this object

Returns
  The texture minification filter for this object

See also
  TextureFilter_e

Reimplemented from Group.

## ◆ TextureMinificationFilter() [2/2]

virtual void TextureMinificationFilter | ( | const int | filter | ) |
| override virtual

Sets the texture minification filter for this object

Parameters

  filter | The new texture minification filter for this object

See also
  TextureFilter_e

Reimplemented from Group.

## ◆ TextureRepeat() [1/2]

virtual bool TextureRepeat | ( |  | ) |
| override virtual

Gets the texturing repeat mode for this object

Returns
  The texture repeat mode for this object

Reimplemented from DisplayObject.

## ◆ TextureRepeat() [2/2]

virtual void TextureRepeat | ( | const int | rep | ) |
| override virtual

Sets the texturing repeat mode for this object

Parameters

  rep | The new texture repeat mode for this object (boolean)

Reimplemented from Group.

## ◆ UpdateBoundingVolume()

virtual void UpdateBoundingVolume | ( |  | ) |
| override virtual

Updates the bounding volume of this object This method should be called if the vertices change for picking and culling to work correctly. This will only update this object. If PerformGroupCullCheck is enabled for one of the objects parents, you may also need to call CalculateParentBoundingBox() to update all of the objects parents.

Reimplemented from DisplayObject.

## Member Data Documentation

## ◆ _multitouchState

MultitouchState _multitouchState
| protected

The current multitouch input state,.

See also
  MultitouchState

The documentation for this class was generated from the following file:

- gls_rso_wrapper.h